#include <io.h>

#include <stdio.h>

#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#include <mmsystem.h>

#include "system.h"

#include "setup.h"

#include "sound.h"

#include "input.h"



int screen_width, screen_height;

HWND hMainWnd;

/*

#define	sc_None			0

#define	sc_Bad			0xff

#define	sc_Return		0x1c

#define	sc_Enter		sc_Return

#define	sc_Escape		0x01

#define	sc_Space		0x39

#define	sc_BackSpace	0x0e

#define	sc_Tab			0x0f

#define	sc_Alt			0x38

#define	sc_Control		0x1d

#define	sc_CapsLock		0x3a

#define	sc_LShift		0x2a

#define	sc_RShift		0x36

#define	sc_UpArrow		0x48

#define	sc_DownArrow	0x50

#define	sc_LeftArrow	0x4b

#define	sc_RightArrow	0x4d

#define	sc_Insert		0x52

#define	sc_Delete		0x53

#define	sc_Home			0x47

#define	sc_End			0x4f

#define	sc_PgUp			0x49

#define	sc_PgDn			0x51

#define	sc_F1			0x3b

#define	sc_F2			0x3c

#define	sc_F3			0x3d

#define	sc_F4			0x3e

#define	sc_F5			0x3f

#define	sc_F6			0x40

#define	sc_F7			0x41

#define	sc_F8			0x42

#define	sc_F9			0x43

#define	sc_F10			0x44

#define	sc_F11			0x57

#define	sc_F12			0x59



#define	sc_1			0x02

#define	sc_2			0x03

#define	sc_3			0x04

#define	sc_4			0x05

#define	sc_5			0x06

#define	sc_6			0x07

#define	sc_7			0x08

#define	sc_8			0x09

#define	sc_9			0x0a

#define	sc_0			0x0b



#define	sc_A			0x1e

#define	sc_B			0x30

#define	sc_C			0x2e

#define	sc_D			0x20

#define	sc_E			0x12

#define	sc_F			0x21

#define	sc_G			0x22

#define	sc_H			0x23

#define	sc_I			0x17

#define	sc_J			0x24

#define	sc_K			0x25

#define	sc_L			0x26

#define	sc_M			0x32

#define	sc_N			0x31

#define	sc_O			0x18

#define	sc_P			0x19

#define	sc_Q			0x10

#define	sc_R			0x13

#define	sc_S			0x1f

#define	sc_T			0x14

#define	sc_U			0x16

#define	sc_V			0x2f

#define	sc_W			0x11

#define	sc_X			0x2d

#define	sc_Y			0x15

#define	sc_Z			0x2c



void IN_KeyEvent(unsigned char key);



static unsigned char winkeytable[256] =

{

	0, 0, 0, 0, 0, 0, 0, 0, sc_BackSpace, sc_Tab, 0, 0, 0, sc_Return, 0, 0,

	0, sc_Control, sc_Alt, 0xe1, sc_CapsLock, 0, 0, 0, 0, 0, 0, sc_Escape, 0, 0, 0, 0,

	sc_Space, sc_PgUp, sc_PgDn, sc_End, sc_Home, sc_LeftArrow, sc_UpArrow, sc_RightArrow, sc_DownArrow, 0, 0, 0, 0, 0, sc_Insert, sc_Delete,

	sc_0, sc_1, sc_2, sc_3, sc_4, sc_5, sc_6, sc_7, sc_8, sc_9, 0, 0, 0, 0, 0, 0,

	   0, sc_A, sc_B, sc_C, sc_D, sc_E, sc_F, sc_G, sc_H, sc_I, sc_J, sc_K, sc_L, sc_M, sc_N, sc_O,

	sc_P, sc_Q, sc_R, sc_S, sc_T, sc_U, sc_V, sc_W, sc_X, sc_Y, sc_Z, 0, 0, 0, 0, 0,

	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

	sc_F1, sc_F2, sc_F3, sc_F4, sc_F5, sc_F6, sc_F7, sc_F8, sc_F9, sc_F10, sc_F11, sc_F12, 0, 0, 0, 0,

	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

};

*/

LRESULT CALLBACK WndProc(HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam)

{

//	unsigned char key;



	switch(iMsg)

	{

		case WM_ERASEBKGND:

		{

			return TRUE;

		} break;



		case WM_CREATE:

		{

			PIXELFORMATDESCRIPTOR pfd = { sizeof(PIXELFORMATDESCRIPTOR), 1, 

				PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,

				PFD_TYPE_RGBA, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

				32, 0, 0, PFD_MAIN_PLANE, 0, 0, 0, 0 };

			int pixelformat;

			HDC hDC;

			HGLRC hRC;



			hDC = GetDC(hWnd);



			if ((pixelformat = ChoosePixelFormat(hDC, &pfd)) == 0)

			{

				MessageBox(NULL, "ChoosePixelFormat failed", "Error", MB_OK);

				return TRUE;

			}



			if (SetPixelFormat(hDC, pixelformat, &pfd) == FALSE)

			{

				MessageBox(NULL, "SetPixelFormat failed", "Error", MB_OK);

				return TRUE;

			}

			

			hRC = wglCreateContext(hDC);

			wglMakeCurrent(hDC, hRC);

		} break;

		

		case WM_SIZE:

			screen_width = LOWORD(lParam);

			screen_height = HIWORD(lParam);

		break;

/*		

		case WM_KEYDOWN:

		if ((lParam & 0x40000000) != 0)	// Only process the message once.

			break;



		key = winkeytable[wParam];

		if (wParam == VK_SHIFT)

		{

			if (GetKeyState(VK_LSHIFT) < 0)

				key = sc_LShift;

			else

				key = sc_RShift;

		}

		if (key)

			IN_KeyEvent(key);

		break;



		case WM_KEYUP:

		key = winkeytable[wParam];

		if (wParam == VK_SHIFT)

		{

			if (GetKeyState(VK_LSHIFT) < 0)

				key = sc_LShift;

			else

				key = sc_RShift;

		}

		if (key)

		{

			key |= 0x80;

			IN_KeyEvent(key);

		}

		break;

*/

/*

		case WM_ACTIVATE:

			if (LOWORD(wParam) != WA_INACTIVE)

				game_mode = gm_play;

			else

				game_mode = gm_pause;

		break;

*/			

		case WM_DESTROY:

		{

			HDC hDC = wglGetCurrentDC();

			HGLRC hRC = wglGetCurrentContext();

			wglMakeCurrent(NULL, NULL);



			if (hRC)

				wglDeleteContext(hRC);

			if (hDC)

				ReleaseDC(hWnd, hDC);

			hMainWnd = NULL;

			PostQuitMessage (0);

			return 0;

		} break;

	}



	return DefWindowProc(hWnd, iMsg, wParam, lParam);

}



void S_Startup()

{

	WNDCLASS wndclass;



	wndclass.style		   = CS_OWNDC;

	wndclass.lpfnWndProc   = WndProc;

	wndclass.cbClsExtra    = 0;

	wndclass.cbWndExtra    = 0;

	wndclass.hInstance	   = GetModuleHandle(NULL);

	wndclass.hIcon		   = 0;//LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(ID_ICON));

	wndclass.hCursor	   = LoadCursor(NULL, IDC_WAIT);

	wndclass.hbrBackground = NULL;

	wndclass.lpszMenuName  = NULL;

	wndclass.lpszClassName = "OpenGLClass";

	RegisterClass(&wndclass);



	if (!DoSetupDlg())

		Quit(0);



	if (ScreenMode == -1)

	{

		hMainWnd = CreateWindow ("OpenGLClass", "WolfGL",

			WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,

			CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,

			NULL, NULL, GetModuleHandle(NULL), NULL);

	}

	else

	{

		hMainWnd = CreateWindow ("OpenGLClass", "WolfGL",

			WS_POPUP|WS_MAXIMIZE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN,

			0, 0, screen_width, screen_height,

			NULL, NULL, GetModuleHandle(NULL), NULL);

	}





//	MoveWindow(hMainWnd, 0,0, 800, 600, TRUE);

	ShowWindow(hMainWnd, SW_SHOWNORMAL);

	UpdateWindow(hMainWnd);

//	ShowCursor(FALSE);



	SetupDirectSound();

	InitDirectInput();

}



void S_Shutdown()

{

	ShutdownDirectInput();

	ShutdownDirectSound();



	if (hMainWnd)

		DestroyWindow(hMainWnd);

//	PostMessage(hMainWnd, WM_CLOSE, 0, 0);



	if (ScreenMode != -1)

		ChangeDisplaySettings(NULL, 0);

}



void S_ProcessEvents()

{

	MSG msg;



	HandleKeyboard();



	while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))

	{



		if (msg.message == WM_QUIT)

		{

			Quit(0);

//			loop = false;

			break;

		}



//		if (!TranslateAccelerator(msg.hwnd, hAccel, &msg))

		{

			TranslateMessage(&msg);

			DispatchMessage(&msg);

		}

	}



/*

	if (game_mode == gm_quit)

	{

		ShowCursor(TRUE);

		SendMessage(hMainWnd, WM_CLOSE, 0, 0);

	}

*/

}



static unsigned long basetime = 0;



int S_GetNewTics()

{

	int newtics;

	unsigned long currtime;



	currtime = timeGetTime();

	if (!basetime)

		basetime = currtime;

	newtics = ((currtime-basetime)*70/1000);



	if (newtics)

		basetime = currtime;



	return newtics;

}



void S_FinishDisplay()

{

	SwapBuffers(wglGetCurrentDC());

}



int S_FileExists(char* name)

{

	struct _finddata_t fileinfo;



	if (_findfirst(name, &fileinfo) != -1)

		return 1;

	else

		return 0;

}



unsigned long S_FileLength(FILE* file)

{

	unsigned long nLen, nCur;



	// Seek is a non const operation

	nCur = ftell(file);

	fseek(file, 0, SEEK_END);

	nLen = ftell(file);

	fseek(file, nCur, SEEK_SET);



	return nLen;

}

